clang 8.0.0

Functions
SValBuilder.cpp File Reference
`#include "clang/StaticAnalyzer/Core/PathSensitive/SValBuilder.h"`
`#include "clang/AST/ASTContext.h"`
`#include "clang/AST/Decl.h"`
`#include "clang/AST/DeclCXX.h"`
`#include "clang/AST/ExprCXX.h"`
`#include "clang/AST/ExprObjC.h"`
`#include "clang/AST/Stmt.h"`
`#include "clang/AST/Type.h"`
`#include "clang/Basic/LLVM.h"`
`#include "clang/Analysis/AnalysisDeclContext.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/AnalysisManager.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/APSIntType.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/BasicValueFactory.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/MemRegion.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/ProgramState.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/ProgramState_Fwd.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/SVals.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/Store.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/SubEngine.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/SymExpr.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/SymbolManager.h"`
`#include "llvm/ADT/APSInt.h"`
`#include "llvm/ADT/None.h"`
`#include "llvm/ADT/Optional.h"`
`#include "llvm/Support/Casting.h"`
`#include "llvm/Support/Compiler.h"`
`#include <cassert>`
`#include <tuple>`
Include dependency graph for SValBuilder.cpp:

Go to the source code of this file.

## Functions
static bool | shouldBeModeledWithNoOp (ASTContext &Context, QualType ToTy, QualType FromTy)
| Recursively check if the pointer types are equal modulo const, volatile, and restrict qualifiers. More...

## Function Documentation

## ◆ shouldBeModeledWithNoOp()

static bool shouldBeModeledWithNoOp | ( | ASTContext & | Context,
|  | QualType | ToTy,
|  | QualType | FromTy
| ) |  |
| static

Recursively check if the pointer types are equal modulo const, volatile, and restrict qualifiers.

Also, assume that all types are similar to 'void'. Assumes the input types are canonical.

Definition at line 457 of file SValBuilder.cpp.

References clang::ASTContext::getUnqualifiedArrayType(), clang::Type::isVoidType(), clang::Qualifiers::removeCVRQualifiers(), and clang::ASTContext::UnwrapSimilarTypes().

Referenced by clang::ento::SValBuilder::evalCast().